<template>
  <PageCard>
    <PageCard
      class="pageCard-padding background-header"
      :bordering="false"
      fontWeight="bold"
      titleSize=".925rem"
      :title="$t('deposit.switcher.title')">
    </PageCard>
    <PageCard
      :bordering="false">
      <div style="padding: 25px;">
        <slider
          :val="value"
          @change="(val) =>$emit('input', val)"></slider>
      </div>
      <div class="pageCard_inner">
        <div class="flex">
          <switchereBtn
            :active="currentMethod==='cardusd'"
            @click="setPaymentMethod('card', 'usd')">
            <img
              style="max-height: 100%; max-width: 100%;"
              src="~/static/deposit/switchere_icons/payment-visa.svg"
              alt="">
            <img
              style="max-height: 100%; max-width: 100%;"
              src="~/static/deposit/switchere_icons/payment-mastercard.svg"
              alt="">
          </switchereBtn>
          <switchereBtn
            :active="currentMethod==='netellerusd'"
            @click="setPaymentMethod('neteller', 'usd')">
            <img
              style="max-height: 100%; max-width: 100%;"
              src="~/static/deposit/switchere_icons/payment-neteller.svg"
              alt="">
          </switchereBtn>
        </div>
        <div class="flex">
          <switchereBtn
            :active="currentMethod==='cryptobtc'"
            @click="setPaymentMethod('crypto', 'btc')">
            <img
              style="max-height: 100%; max-width: 100%;"
              src="~/static/deposit/switchere_icons/BTC.svg"
              alt="">
          </switchereBtn>
          <switchereBtn
            :active="currentMethod==='cryptobch'"
            @click="setPaymentMethod('crypto', 'bch')">
            <img
              style="max-height: 100%; max-width: 100%;"
              src="~/static/deposit/switchere_icons/BCH.svg"
              alt="">
          </switchereBtn>
          <switchereBtn
            :active="currentMethod==='cryptodash'"
            @click="setPaymentMethod('crypto', 'dash')">
            <img
              style="max-height: 100%; max-width: 100%;"
              src="~/static/deposit/switchere_icons/DASH.svg"
              alt="">
          </switchereBtn>
          <switchereBtn
            :active="currentMethod==='cryptoeth'"
            @click="setPaymentMethod('crypto', 'eth')">
            <img
              style="max-height: 100%; max-width: 100%;"
              src="~/static/deposit/switchere_icons/ETH.svg"
              alt="">
          </switchereBtn>
          <switchereBtn
            :active="currentMethod==='cryptolink'"
            @click="setPaymentMethod('crypto', 'link')">
            <img
              style="max-height: 100%; max-width: 100%;"
              src="~/static/deposit/switchere_icons/LINK.svg"
              alt="">
          </switchereBtn>
        </div>
        <div class="flex">
          <switchereBtn
            :active="currentMethod==='cryptoltc'"
            @click="setPaymentMethod('crypto', 'ltc')">
            <img
              style="max-height: 100%; max-width: 100%;"
              src="~/static/deposit/switchere_icons/LTC.svg"
              alt="">
          </switchereBtn>
          <switchereBtn
            :active="currentMethod==='cryptousdt20'"
            @click="setPaymentMethod('crypto', 'usdt20')">
            <img
              style="max-height: 100%; max-width: 100%;"
              src="~/static/deposit/switchere_icons/USDT20.svg"
              alt="">
          </switchereBtn>
          <switchereBtn
            :active="currentMethod==='cryptoxlm'"
            @click="setPaymentMethod('crypto', 'xlm')">
            <img
              style="max-height: 100%; max-width: 100%;"
              src="~/static/deposit/switchere_icons/XLM.svg"
              alt="">
          </switchereBtn>
          <switchereBtn
            :active="currentMethod==='cryptoxrp'"
            @click="setPaymentMethod('crypto', 'xrp')">
            <img
              style="max-height: 100%; max-width: 100%;"
              src="~/static/deposit/switchere_icons/XRP.svg"
              alt="">
          </switchereBtn>
          <div style="min-width: 40px; padding: 5px 10px; flex: 1;"></div>
        </div>
      </div>
      <div style="padding: 20px 10px 20px 0px;">
        <ul class="deposit_steps">
          <li
            class="deposit_steps-item"
            v-for="(item, key) in steps"
            :key="key">
            <div
              class="deposit_steps-point"
              :style="{'backgroundColor': key===0 ? '#00bdc5' : key===1 ? '#fea911' : '#36d253'}"><span>{{key+1}}</span>
            </div>
            <div class="deposit_steps-title">
              <div>
                {{item}}
              </div>
              <div
                v-if="key===1"
                style="color: #d33e41;">
                {{$t('deposit.stepsWarning')}}
              </div>
            </div>
          </li>
        </ul>
      </div>
      <div class="text-center">
        <BtnSign
          @click="createInvoice"
          :loading="loading || loadingMemo"
          backgroundColor="#70c666"
          color="#283349"
          class="mt-15">
          {{$t('deposit.switcher.btn')}}
        </BtnSign>
      </div>
      <div class="pageCard_inner">
        <div style="color: #84878b;">
          {{$t('deposit.switcher.subtitle')}}
        </div>
        <div class="color-white">
          {{$t('deposit.switcher.subtitle_1')}}
        </div>
      </div>
    </PageCard>
    <PageCard :bordering="false">
      <div
        class="pageCard_inner pageCard_video"
        style="background-color: #1b2229">
        <div style="position: relative; border-radius: 16px; overflow: hidden; -webkit-mask-image: -webkit-radial-gradient(white, black); line-height: 0px;">
          <img
            src="~/static/backgrounds/Deposit_preview.png"
            style="position: absolute; max-width: 100%; z-index: 2; top: 0px; left: 0px;"
            ref="img"
            v-if="showPreview"
            @click="startVideo"
            alt="">
          <iframe
            style="width: 100%;border: 0px;"
            :style="{height: iframeHeight+'px'}"
            src="https://www.youtube.com/embed/wkHYkQ4fm-k"
            frameborder="0"
            ref="iframe"
            allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture"
            allowfullscreen></iframe>
        </div>
      </div>
    </PageCard>
    <PageCard :bordering="false">
      <div class="exchange_info text-center">
        <br>
        <div class="exchange_info-title">{{$t('deposit.switcher.service')}}</div>
        <br>
        <img
          class="exchange_info-img"
          src="~/static/deposit/switchhere.png"
          alt="">
        <BtnSign
          @click="createInvoice"
          :loading="loading || loadingMemo"
          backgroundColor="#70c666"
          color="#283349"
          class="mt-15">
          {{$t('deposit.switcher.btn')}}
        </BtnSign>
      </div>
    </PageCard>
  </PageCard>
</template>

<script>
  import PageCard from '~/components/UI/PageCard';
  import Btn from '~/components/UI/BtnSign';
  import IconCopy from '~/components/UI/icons/icon-copy';
  import copyClipboard from '~/components/utils/copy';
  import BtnDark from '~/components/UI/BtnSign_dark';
  import BtnSign from '~/components/UI/BtnSign';
  import switchereBtn from './switchereMethodsBtn';
  import slider from './../components/slider';

  export default {
    name: "SwitchereBlock",
    props: {
      accountName: {
        type: String,
        default: localStorage.getItem('accountname')
      },
      memo: {
        type: String,
        default: 'Checkout 16Bit.Game!'
      },
      loadingMemo: {
        type: Boolean,
        default: false
      },
      value: {
        type: Number,
        default: 5
      }
    },
    data() {
      return {
        iframeHeight: 150,
        showPreview: true,
        currentMethod: 'cardusd',
        paymentType: 'card',
        paymentMethod: 'usd',
        payinAmount: 0,
        loading: false
      }
    },
    components: {
      PageCard,
      Btn,
      IconCopy,
      BtnDark,
      BtnSign,
      switchereBtn,
      slider
    },
    events: {
      'deposit:opened': function () {
        this.setHeight();
      }
    },
    computed: {
      steps() {
        return this.$t('deposit.steps');
      },
      link() {
        const memo = (!this.memo || this.memo === '-') ? 'Checkout 16Bit.Game!' : this.memo;
        if (this.paymentMethod === 'usd') {
          return `https://switchere.com/order/new?r=4jxgdlqyev5b&payinCurrency=${this.paymentMethod.toUpperCase()}&payinAmount=${this.payinAmount}&payoutCurrency=EOS&dstAddress=${this.accountName}&memoId=${memo}&payinMethod=ecommpay&payinSubMethod=${this.paymentType}&payoutMethod=crypto&payoutSubMethod=none`;
        } else {
          return `https://switchere.com/order/new?r=4jxgdlqyev5b&payinCurrency=${this.paymentMethod.toUpperCase()}&payinAmount=${this.payinAmount}&payoutCurrency=EOS&dstAddress=${this.accountName}&memoId=${memo}&payinMethod=crypto&payinSubMethod=none&payoutMethod=crypto&payoutSubMethod=none`;
        }
      }
    },
    methods: {
      async createInvoice() {
        this.loading = true;
        const memo = (!this.memo || this.memo === '-') ? 'Checkout 16Bit.Game!' : this.memo;
        const data = {
          payoutAmount: this.value,
          payinCurrency: this.paymentMethod.toUpperCase(),
          payinSubMethod: this.paymentType,
          address: this.accountName,
          memoId: memo
        };
        const [err, res] = await this.$store.dispatch('deposit/processingSwitchere', data);
        if (!err && res && res.url) {
          window.location.href = res.url;
        }
        this.loading = false;
      },
      setPaymentMethod(type, method) {
        this.paymentType = type;
        this.paymentMethod = method;
        this.currentMethod = type + method;
      },
      setHeight() {
        this.iframeHeight = this.$refs['img'].offsetHeight;
      },
      startVideo() {
        this.showPreview = false;
        this.$refs['iframe'].src += '?autoplay=1';
      },
      copy(text) {
        copyClipboard(text, this.$t('common.copy'))
      }
    }
  }
</script>
<style
  lang="scss"
  scoped>
  .background-header {
    background-color: #303d55;
  }

  .pageCard {
    &_inner {
      line-height: 1.4;
      padding: 20px;
      background-color: #1e283a;
    }
    &_video {
      padding: 40px 20px;
      background-color: #1b2229;
      color: #84878b;
      white-space: pre-line;
      line-height: 1.4;
    }
  }

  .payment_info {
    &-item {
      display: flex;
      align-items: center;
      justify-content: space-between;
      padding: 10px 0px;
      &:not(:last-child) {
        border-bottom: 1px dashed #394862;
      }
      &-label {
        color: #8a8b8e;
      }
      &-val {
        color: #589ba6;
        margin-left: 10px;
        white-space: nowrap;
        text-overflow: ellipsis;
        overflow: hidden;
        max-width: 180px;
        width: 100%;
      }
    }
  }

  .exchange_info {
    background-color: #0c1c49;
    text-align: center;
    padding: 20px 0px;
    &-title {
      white-space: pre-line;
      text-transform: uppercase;
      font-weight: bold;
      max-width: 100%;
      margin: auto;
    }
    &-subtitle {
      color: #7f848c;
    }
    &-img {
      max-width: 200px;
      width: 100%;
    }
  }
</style>
